#pragma once

#include <mutex>
#include <fftw3.h>
#include <VulcanoLE/Audio/Types.h>

class FFT {
public:
    FFT();
    ~FFT();
    void process(stereoSample *frame);
    outputSample *getData();
    bool prepareInput(stereoSample *buffer, uint32_t sampleSize);
protected:
    double *m_fftwInputLeft{};
    double *m_fftwInputRight{};
    fftw_complex *m_fftwOutputLeft{};
    fftw_complex *m_fftwOutputRight{};
    outputSample *m_sample = new outputSample(FFT_SIZE);
    fftw_plan m_fftwPlanLeft{};
    fftw_plan m_fftwPlanRight{};
    std::mutex m_mtx;
    size_t m_fftwResults;
};
