#pragma once

#include <VulcanoLE/Visual/VIZ.h>
#include <VulcanoLE/Audio/AudioGrabber.h>
#include <VulcanoLE/Keyboards/Vulcan121.h>

namespace VIZ {
    class Loudness : public VIZ {
    public:
        Loudness(AudioGrabber *pGrabber, Vulcan121 *pVulcan121);
        ~Loudness() override = default;
        void onSetup() override;
        void onTick(float delta) override;
        void setForChannel(float value, int channel);
        void drawFrame(int toRow);
        const char *name() override;
        std::string m_name = "Loudness Meter";
    protected:
        rgba colours[3] = {
                { 0,   0,   255, 80 },
                { 0,   255, 0,   80 },
                { 255, 0,   0, 40 }
        };
        double tailFactor = 0;
        led_map *data = Vulcan121::createEmptyLEDMap();
    };
}

