#pragma once

#include <vector>
#include <VulcanoLE/Scripts/Spectrum.h>

#define VIZSIZE 4

using micro = std::chrono::duration<double, std::micro>;

namespace VIZ {
    struct VisPlugins {
        int mode = 0;
        void init(HIDHelper *, AudioGrabber *);
        void onStartup();
        void onTick();
        void onShutdown();
        void setCurrentMode(int);
        ~VisPlugins();
        VUtils::Environment *env{};
    protected:
        VIZ *viz[VIZSIZE]{};
        VIZ *currentVis{};
        Vulcan121 *keyboard{};
        AudioGrabber *grabber{};
        std::chrono::time_point<std::chrono::system_clock, micro> start;
    };
}

