#include <VUtils/Math.h>

namespace VUtils {
    double Math::clamp(double value, double min, double max) {
        return value > max ? max : value < min ? min : value;
    }

    double Math::lerp(double a, double b, double f) {
        return (a + (b - a) * f);
    }
    double Math::bezierBlend(double t) {
        return t * t * (3.0 - 2.0 * t);
    }
    double Math::easeIn(double ratio) {
        return ratio * ratio * ratio;
    }
}